/***************************************************************************
 *   Copyright (C) 2008 by Thomas Schildknecht <danakil@gmail.com>         *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   51 Franklin Street, Fifth Floor, Boston, MA  02110-1301  USA .        *
 ***************************************************************************/

#ifndef PLASMAPANELSPACER_HEADER
#define PLASMAPANELSPACER_HEADER

#include <Plasma/Applet>
#include "ui_panelspacerConfig.h"


class PlasmaPanelSpacer : public Plasma::Applet
{
    Q_OBJECT
    public:
        PlasmaPanelSpacer(QObject *parent, const QVariantList &args);

        void init();
        void paintInterface(QPainter *painter,
                const QStyleOptionGraphicsItem *option,
                const QRect& contentsRect);        

    protected :
        void createConfigurationInterface(KConfigDialog *parent);

    public slots : 
        void slotSpacerStretchChanged(bool checkstate);
        void slotSpacerSizeChanged(int size);
        void slotSeparatorPositionChanged(int index);
        void slotSeparatorStyleChanged(int index);
        void slotConfigClosed();

    protected slots:    
        
        void configAccepted();
        void constraintsEvent(Plasma::Constraints constraints);

    private:
        Ui::panelspacerConfig uiConfig;

        bool m_spacerStretch;
        bool m_configureMode;
        int m_spacerSize;
        int m_separatorPosition;
        int m_separatorStyle;
        int m_separatorWidth;
};
 
K_EXPORT_PLASMA_APPLET(panelspacer, PlasmaPanelSpacer)
#endif
